"""
Created on Fri Mar 13 14:44:48 2020

@author: tence
"""
import os 
import numpy as np
import pandas as pd
from netCDF4 import Dataset
from accessoires import jour_davant_dapres, is_before, doy_to_date

def sort_folder(name):
    return(10000*int(name[29:33]) + int(name[34:37]))
    
def sort_folder_T(name):
    return(10000*int(name[37:41]) + int(name[42:45]))

path = '/home/tence/Documents/sshfs-tmp45/MLS_data/H2O/'

dossier = os.listdir(path)
dossier = [d for d in dossier if d[:3]=='MLS']
dossier = sorted(dossier, key=sort_folder)

path_T = '/home/tence/Documents/sshfs-tmp45/MLS_data/T/'

dossier_T = os.listdir(path_T)
dossier_T = [d for d in dossier_T if d[:3]=='MLS']
dossier_T = sorted(dossier_T, key=sort_folder_T)

fontsize=11
R = 8.3143                       ## Constante des gazs parfaits (J.K-1.mol-1)
N_avo = 6.022e23                 ## Avogadro
M_air = 28.97e-3                 ## kg/mol
M_CO = 28.01e-3                  ## kg/mol
M_H2O = 18.01528e-3              ## kg/mol
M_CH3 = 41.05e-3                 ## kg/mol
g = 9.80665                      ## m.s−2
R_earth = 6.371e6                ## Rayon de la Terre m

lon_min, lon_max = -180, 180
lat_min, lat_max = -82, -20

P_levels = list(100*np.array([1.0000000e+03, 8.2540417e+02, 6.8129205e+02, 5.6234131e+02,
       4.6415887e+02, 3.8311868e+02, 3.1622775e+02, 2.6101572e+02,
       2.1544347e+02, 1.7782794e+02, 1.4677992e+02, 1.2115276e+02,
       1.0000000e+02, 8.2540421e+01, 6.8129204e+01, 5.6234131e+01,
       4.6415890e+01, 3.8311867e+01, 3.1622776e+01, 2.6101572e+01,
       2.1544348e+01, 1.7782795e+01, 1.4677993e+01, 1.2115276e+01,
       1.0000000e+01, 8.2540417e+00, 6.8129206e+00, 5.6234131e+00,
       4.6415887e+00, 3.8311868e+00, 3.1622777e+00, 2.6101573e+00,
       2.1544347e+00, 1.7782794e+00, 1.4677993e+00, 1.2115277e+00,
       1.0000000e+00, 6.8129206e-01, 4.6415889e-01, 3.1622776e-01,
       2.1544346e-01, 1.4677992e-01, 1.0000000e-01, 4.6415888e-02,
       2.1544347e-02, 9.9999998e-03, 4.6415888e-03, 2.1544348e-03,
       1.0000000e-03, 4.6415889e-04, 2.1544346e-04, 9.9999997e-05,
       4.6415887e-05, 2.1544347e-05, 9.9999997e-06]))
P0 = 101325

datas_H2O, datas_H2O_precision, datas_quality, datas_T, lats, lons, dates, datas_Ptropo, datas_Teq, datas_ind_Teqs_380 = [], [], [], [], [], [], [], [], [], []  
for d in range(len(dossier)):  
    dataset = Dataset(path+dossier[d])
    dataset.set_auto_mask(False)
    H2O_group = dataset.groups["HDFEOS"].groups["SWATHS"].groups["H2O"]
    data_fields = H2O_group.groups["Data Fields"]
    geoloc_fields = H2O_group.groups["Geolocation Fields"]
    latitude = geoloc_fields.variables["Latitude"][:]
    longitude = geoloc_fields.variables["Longitude"][:]
    time = geoloc_fields.variables["Time"][:]
    H2O = data_fields.variables["H2O"][:]
    convergence = data_fields.variables["Convergence"][:]
    H2O_precision = data_fields.variables["L2gpPrecision"][:]
    Status_flag = data_fields.variables["Status"][:]
    Quality = data_fields.variables["Quality"][:]
    year = int(dossier[d][29:33])
    doy = int(dossier[d][34:37])
    jour = doy_to_date(doy, year)
    print(jour)

    d_T_temp = [fil for fil in dossier_T if fil[37:41]==dossier[d][29:33] and fil[42:45]==dossier[d][34:37]]
    dataset_T = Dataset(path_T+d_T_temp[0])
    
    WMO_P_tropos = dataset_T.groups["HDFEOS"].groups["SWATHS"].groups["WMOTPPressure"].groups["Data Fields"].variables["WMOTPPressure"][:]
    T = dataset_T.groups["HDFEOS"].groups["SWATHS"].groups["Temperature"].groups["Data Fields"].variables["Temperature"][:]

    for i in range(len(latitude)):
        if Status_flag[i]%2==0 and convergence[i] <= 2 and Quality[i] >0.7:
        #if True:
            if lon_min <= longitude[i] <= lon_max and lat_min <= latitude[i] <= lat_max:
                dates.append(jour)
                lats.append(latitude[i])
                lons.append(longitude[i])
                datas_H2O.append(H2O[i])
                datas_H2O_precision.append(H2O_precision[i])
                datas_Ptropo.append(100*WMO_P_tropos[i])
                Teq = list(np.array(T[i])*((P0/np.array(P_levels))**0.286))
                Teq.append(380)
                Teq = sorted(Teq)
                ind_Teq_380 = Teq.index(380)
                Teq.remove(380)
                datas_T.append(T[i])
                datas_Teq.append(Teq)
                datas_ind_Teqs_380.append(ind_Teq_380)
                
lats, lons, datas_H2O, dates, datas_Ptropo, datas_Teq, datas_ind_Teqs_380 = np.array(lats), np.array(lons), np.array(datas_H2O), np.array(dates), np.array(datas_Ptropo), np.array(datas_Teq), np.array(datas_ind_Teqs_380)

P_demi_levels = []
for i in range(len(P_levels)-1):
    P_demi_levels.append(np.exp((np.log(P_levels[i])+np.log(P_levels[i+1]))/2))
    
intervalles = pd.unique(dates[:])
ind_bas = 7
ind_haut = 53
P_lvl = P_levels[ind_bas]
P_lvl_demi = P_demi_levels[ind_bas-1]
P_lvl2 = P_levels[ind_haut]
P_lvl2_demi = P_demi_levels[ind_haut]
print('Niveaux '+str(int(P_lvl/100))+' hPa à '+str(int(P_lvl2/100))+' hPa')

datas_H2O_err = [0 for i in P_levels]
datas_H2O_err[6:47] = 15, 20, 25, 20, 15, 12, 8, 9, 9, 0, 4, 0, 0 , 0, 5, 0, 0, 0, 19, 0, 0, 0, 5, 0, 0, 0, 7, 0, 0, 0, 7, 0, 8, 0, 11, 0, 14, 17, 19, 17, 23, 40

datas_H2O_conc, datas_air_conc, datas_H2O_conc_err_moins, datas_H2O_conc_err_plus  = [[] for x in datas_H2O], [[] for x in datas_H2O], [[] for x in datas_H2O], [[] for x in datas_H2O]
datas_VMR_col_H2O, datas_VMR_col_H2O_err_moins, datas_VMR_col_H2O_err_plus = [], [], []

for prof in range(len(datas_H2O)):
    ind_Ptrop = datas_ind_Teqs_380[prof]
    for pr in range(ind_Ptrop, P_levels.index(P_lvl2)+1): # HERE IS WHERE WE SELECT THE INDICES USED TO RESTRICT TO DATA IN P LEVELS
        datas_H2O_conc[prof].append(datas_H2O[prof][pr]*(P_demi_levels[pr-1] - P_demi_levels[pr])/(g*M_air))
        datas_H2O_conc_err_moins[prof].append((datas_H2O[prof][pr] - datas_H2O[prof][pr]*datas_H2O_err[pr])*((P_demi_levels[pr-1] - P_demi_levels[pr])/(g*M_air)))
        datas_H2O_conc_err_plus[prof].append((datas_H2O[prof][pr] + datas_H2O[prof][pr]*datas_H2O_err[pr])*((P_demi_levels[pr-1] - P_demi_levels[pr])/(g*M_air)))
        datas_air_conc[prof].append((P_demi_levels[pr-1] - P_demi_levels[pr])/(g*M_air))

    datas_VMR_col_H2O.append(sum(datas_H2O_conc[prof])/sum(datas_air_conc[prof]))
    datas_VMR_col_H2O_err_moins.append(sum(datas_H2O_conc_err_moins[prof])/sum(datas_air_conc[prof]))
    datas_VMR_col_H2O_err_plus.append(sum(datas_H2O_conc_err_plus[prof])/sum(datas_air_conc[prof]))
    
intervalles_length = []
for jj in range(len(intervalles)):
    date_debut = intervalles[jj]
    date_fin = date_debut
    print(date_debut, date_fin)
    
    ind_date_deb = np.where(dates==date_debut)[0][0]
    ind_date_fin = np.where(dates==date_fin)[0][-1]
    intervalles_length.append(len(datas_H2O[ind_date_deb:ind_date_fin+1]))

ind_debut_run = np.where(dates==intervalles[0])[0][0]
VMR_H2O, VMR_H2O_err_moins, VMR_H2O_err_plus = [[] for y in range(len(intervalles))], [[] for y in range(len(intervalles))], [[] for y in range(len(intervalles))]
for inter in range(1, len(intervalles)):
    VMR_H2O[inter-1] = datas_VMR_col_H2O[ind_debut_run:][sum(intervalles_length[:inter-1]):sum(intervalles_length[:inter])]
    VMR_H2O_err_moins[inter-1] = datas_VMR_col_H2O_err_moins[ind_debut_run:][sum(intervalles_length[:inter-1]):sum(intervalles_length[:inter])]
    VMR_H2O_err_plus[inter-1] = datas_VMR_col_H2O_err_plus[ind_debut_run:][sum(intervalles_length[:inter-1]):sum(intervalles_length[:inter])]

VMR_H2O[-1] = datas_VMR_col_H2O[ind_debut_run:][sum(intervalles_length[:-1]):sum(intervalles_length)]
VMR_H2O_err_moins[-1] = datas_VMR_col_H2O_err_moins[ind_debut_run:][sum(intervalles_length[:-1]):sum(intervalles_length)]
VMR_H2O_err_plus[-1] = datas_VMR_col_H2O_err_plus[ind_debut_run:][sum(intervalles_length[:-1]):sum(intervalles_length)]

mean_VMR_H2O = [np.mean(X) for X in VMR_H2O]
mean_VMR_H2O_err_moins = [np.mean(X) for X in VMR_H2O_err_moins]
mean_VMR_H2O_err_plus = [np.mean(X) for X in VMR_H2O_err_plus]

partial_air_col = (P_lvl_demi - P_lvl2_demi)*N_avo/(g*M_air)
surface_utile = 2*np.pi*(R_earth**2)*(np.sin(lat_max*np.pi/180)-np.sin(lat_min*np.pi/180))
total_air_molecules = partial_air_col*surface_utile

N_H2O_molecules = [total_air_molecules*mean_VMR_H2O[i] for i in range(len(mean_VMR_H2O))]
N_H2O_molecules_err_moins = [total_air_molecules*mean_VMR_H2O_err_moins[i] for i in range(len(mean_VMR_H2O_err_moins))]
N_H2O_molecules_err_plus = [total_air_molecules*mean_VMR_H2O_err_plus[i] for i in range(len(mean_VMR_H2O_err_plus))]

mass_H2O = [x*M_H2O/(N_avo*1000*1000) for x in N_H2O_molecules]  
mass_H2O_err_moins = [x*M_H2O/(N_avo*1000*1000) for x in N_H2O_molecules_err_moins]
mass_H2O_err_plus = [x*M_H2O/(N_avo*1000*1000) for x in N_H2O_molecules_err_plus]

date_debut_season = '01-06'
date_fin_season = '04-04'

dates_commun = [date_debut_season+'-2019']
jour = dates_commun[0]
while not jour == date_fin_season +'-2020':
    _, jour = jour_davant_dapres(jour)
    dates_commun.append(jour)
dates_commun = [d[:2]+'/'+d[3:5] for d in dates_commun]

mass_H2O_2015 = mass_H2O[np.where(intervalles==date_debut_season+'-2015')[0][0]:np.where(intervalles==date_fin_season+'-2016')[0][0]]
mass_H2O_2016 = mass_H2O[np.where(intervalles==date_debut_season+'-2016')[0][0]:np.where(intervalles==date_fin_season+'-2017')[0][0]]
mass_H2O_2017 = mass_H2O[np.where(intervalles==date_debut_season+'-2017')[0][0]:np.where(intervalles==date_fin_season+'-2018')[0][0]]
mass_H2O_2018 = mass_H2O[np.where(intervalles==date_debut_season+'-2018')[0][0]:np.where(intervalles==date_fin_season+'-2019')[0][0]]
mass_H2O_2020 = mass_H2O[np.where(intervalles==date_debut_season+'-2019')[0][0]:np.where(intervalles==date_fin_season+'-2020')[0][0]]

mass_H2O_2015_err_moins = mass_H2O_err_moins[np.where(intervalles==date_debut_season+'-2015')[0][0]:np.where(intervalles==date_fin_season+'-2016')[0][0]]
mass_H2O_2016_err_moins = mass_H2O_err_moins[np.where(intervalles==date_debut_season+'-2016')[0][0]:np.where(intervalles==date_fin_season+'-2017')[0][0]]
mass_H2O_2017_err_moins = mass_H2O_err_moins[np.where(intervalles==date_debut_season+'-2017')[0][0]:np.where(intervalles==date_fin_season+'-2018')[0][0]]
mass_H2O_2018_err_moins = mass_H2O_err_moins[np.where(intervalles==date_debut_season+'-2018')[0][0]:np.where(intervalles==date_fin_season+'-2019')[0][0]]
mass_H2O_2020_err_moins = mass_H2O_err_moins[np.where(intervalles==date_debut_season+'-2019')[0][0]:np.where(intervalles==date_fin_season+'-2020')[0][0]]

mass_H2O_2015_err_plus = mass_H2O_err_plus[np.where(intervalles==date_debut_season+'-2015')[0][0]:np.where(intervalles==date_fin_season+'-2016')[0][0]]
mass_H2O_2016_err_plus = mass_H2O_err_plus[np.where(intervalles==date_debut_season+'-2016')[0][0]:np.where(intervalles==date_fin_season+'-2017')[0][0]]
mass_H2O_2017_err_plus = mass_H2O_err_plus[np.where(intervalles==date_debut_season+'-2017')[0][0]:np.where(intervalles==date_fin_season+'-2018')[0][0]]
mass_H2O_2018_err_plus = mass_H2O_err_plus[np.where(intervalles==date_debut_season+'-2018')[0][0]:np.where(intervalles==date_fin_season+'-2019')[0][0]]
mass_H2O_2020_err_plus = mass_H2O_err_plus[np.where(intervalles==date_debut_season+'-2019')[0][0]:np.where(intervalles==date_fin_season+'-2020')[0][0]]

dates_2015 = intervalles[np.where(intervalles==date_debut_season+'-2015')[0][0]:np.where(intervalles==date_fin_season+'-2016')[0][0]]
dates_2015 = [x[:2]+'/'+x[3:5] for x in dates_2015]
dates_2016 = intervalles[np.where(intervalles==date_debut_season+'-2016')[0][0]:np.where(intervalles==date_fin_season+'-2017')[0][0]]
dates_2016 = [x[:2]+'/'+x[3:5] for x in dates_2016]
dates_2017 = intervalles[np.where(intervalles==date_debut_season+'-2017')[0][0]:np.where(intervalles==date_fin_season+'-2018')[0][0]]
dates_2017 = [x[:2]+'/'+x[3:5] for x in dates_2017]
dates_2018 = intervalles[np.where(intervalles==date_debut_season+'-2018')[0][0]:np.where(intervalles==date_fin_season+'-2019')[0][0]]
dates_2018 = [x[:2]+'/'+x[3:5] for x in dates_2018]
dates_2020 = intervalles[np.where(intervalles==date_debut_season+'-2019')[0][0]:np.where(intervalles==date_fin_season+'-2020')[0][0]]
dates_2020 = [x[:2]+'/'+x[3:5] for x in dates_2020]

H2O_masses = [mass_H2O_2020, mass_H2O_2018, mass_H2O_2017, mass_H2O_2016, mass_H2O_2015]
H2O_masses_err_moins = [mass_H2O_2020_err_moins, mass_H2O_2018_err_moins, mass_H2O_2017_err_moins, mass_H2O_2016_err_moins, mass_H2O_2015_err_moins]
H2O_masses_err_plus = [mass_H2O_2020_err_plus, mass_H2O_2018_err_plus, mass_H2O_2017_err_plus, mass_H2O_2016_err_plus, mass_H2O_2015_err_plus]
labels = ['2019-2020', '2018-2019', '2017-2018', '2016-2017', '2015-2016'] 
dates2 = [dates_2020, dates_2018, dates_2017, dates_2016, dates_2015]

for x in range(len(dates2)):
    for i in range(1, len(dates_commun)):
        if dates_commun[i] not in dates2[x]:
            if is_before(dates_commun[i], dates2[x][0]) == 'Avant':
                H2O_masses[x] = [np.nan] + H2O_masses[x]
                H2O_masses_err_moins[x] = [np.nan] + H2O_masses_err_moins[x]
                H2O_masses_err_plus[x] = [np.nan] + H2O_masses_err_plus[x]
            elif is_before(dates_commun[i], dates2[x][-1]) == 'Apres':
                H2O_masses[x] = H2O_masses[x] + [np.nan] 
                H2O_masses_err_moins[x] = H2O_masses_err_moins[x] + [np.nan] 
                H2O_masses_err_plus[x] = H2O_masses_err_plus[x] + [np.nan] 
            else:
                ind = dates2[x].index(dates_commun[i-1])
                dates2[x] = dates2[x][:ind+1] + [dates_commun[i]] + dates2[x][ind+1:]
                H2O_masses[x] = H2O_masses[x][:ind+1] + [np.nan] + H2O_masses[x][ind+1:]
                H2O_masses_err_moins[x] = H2O_masses_err_moins[x][:ind+1] + [np.nan] + H2O_masses_err_moins[x][ind+1:]
                H2O_masses_err_plus[x] = H2O_masses_err_plus[x][:ind+1] + [np.nan] + H2O_masses_err_plus[x][ind+1:]


#erreur_moy = np.mean(100*np.array(mass_CO_err)/np.array(mass_CO))
arrondi = 6
name_file = 'MLS_H2O_mean_masses_data-2015-2020_Teq_380.txt'
file_H2O = open(name_file, 'w')
file_H2O.write('Dates commun' +'          '+'2019/20'+'          '+'2018/19'+'          '+'2017/18'+'          '+'2016/17'+'          '+'2015/16'+'\n')
for i in range(len(dates_commun)):
    file_H2O.write(dates_commun[i] +'          '+ str(round(H2O_masses[0][i], arrondi)) +'          '+ str(round(H2O_masses[1][i], arrondi)) +'          '+ str(round(H2O_masses[2][i], arrondi)) +'          '+ str(round(H2O_masses[3][i], arrondi)) +'          '+ str(round(H2O_masses[4][i], arrondi))+'\n')
file_H2O.close()

name_file_err_moins = 'MLS_H2O_err_moins_mean_masses_data-2015-2020_Teq_380.txt'
file_H2O_err_moins = open(name_file_err_moins, 'w')
file_H2O_err_moins.write('Dates commun' +'          '+'2019/20'+'          '+'2018/19'+'          '+'2017/18'+'          '+'2016/17'+'          '+'2015/16'+'\n')
for i in range(len(dates_commun)):
    file_H2O_err_moins.write(dates_commun[i] +'          '+ str(round(H2O_masses_err_moins[0][i], arrondi)) +'          '+ str(round(H2O_masses_err_moins[1][i], arrondi)) +'          '+ str(round(H2O_masses_err_moins[2][i], arrondi)) +'          '+ str(round(H2O_masses_err_moins[3][i], arrondi)) +'          '+ str(round(H2O_masses_err_moins[4][i], arrondi))+'\n')
file_H2O_err_moins.close()

name_file_err_plus = 'MLS_H2O_err_plus_mean_masses_data-2015-2020_Teq_380.txt'
file_H2O_err_plus = open(name_file_err_plus, 'w')
file_H2O_err_plus.write('Dates commun' +'          '+'2019/20'+'          '+'2018/19'+'          '+'2017/18'+'          '+'2016/17'+'          '+'2015/16'+'\n')
for i in range(len(dates_commun)):
    file_H2O_err_plus.write(dates_commun[i] +'          '+ str(round(H2O_masses_err_plus[0][i], arrondi)) +'          '+ str(round(H2O_masses_err_plus[1][i], arrondi)) +'          '+ str(round(H2O_masses_err_plus[2][i], arrondi)) +'          '+ str(round(H2O_masses_err_plus[3][i], arrondi)) +'          '+ str(round(H2O_masses_err_plus[4][i], arrondi))+'\n')
file_H2O_err_plus.close()